var matr:array[0..3,0..15,0..15] of byte;
    chr_fill:array[0..255] of byte;
    chr_drct:array[0..3,0..255] of single;
    chr_arr:array[0..255,0..7] of byte;
    chr_srtd:array[0..255] of byte;

procedure scanchars;
var tc:array[0..7,0..7] of byte;
    x,y,z,i,j:integer;
    ch:char;
    tmp:single;
begin
   writeln('Scanning charset');
   asm
   push es
   push bp
   push ds
   mov ax,1130h
   mov bh,03
   int 10h
   mov si,bp
   mov ax,ds
   mov bx,es
   mov es,ax
   mov ds,bx
   mov di,offset chr_arr
   mov cx,2048
   rep movsb
   pop ds
   pop bp
   pop es
   end;
   for x:=0 to 255 do begin
      for i:=0 to 7 do begin
         z:=chr_arr[x,i];
         for j:=0 to 7 do begin
            tc[i,7-j]:=z mod 2;
            z:=z div 2;
         end;
      end;
      y:=0; for i:=0 to 7 do for j:=0 to 7 do y:=y+tc[i,j];
      chr_fill[x]:=y;
      chr_drct[0,x]:=0;
      chr_drct[1,x]:=0;
      chr_drct[2,x]:=0;
      chr_drct[3,x]:=0;
      for i:=0 to 6 do for j:=0 to 6 do begin
         y:=abs(tc[i,j]-tc[i+1,j])+abs(tc[i,j+1]-tc[i+1,j+1])-
            abs(tc[i,j]-tc[i,j+1])-abs(tc[i+1,j]-tc[i+1,j+1]);
         if y>0 then chr_drct[0,x]:=chr_drct[0,x]+1;
         if y<0 then chr_drct[2,x]:=chr_drct[2,x]+1;
         y:=abs(tc[i,j]-tc[i+1,j+1])-abs(tc[i+1,j]-tc[i,j+1]);
         if y>0 then chr_drct[1,x]:=chr_drct[1,x]+1;
         if y<0 then chr_drct[3,x]:=chr_drct[3,x]+1;
      end;
      tmp:=chr_drct[0,x]+chr_drct[1,x]+chr_drct[2,x]+chr_drct[3,x];
      chr_drct[0,x]:=chr_drct[0,x]/(tmp+0.01);
      chr_drct[1,x]:=chr_drct[1,x]/(tmp+0.01);
      chr_drct[2,x]:=chr_drct[2,x]/(tmp+0.01);
      chr_drct[3,x]:=chr_drct[3,x]/(tmp+0.01);
   end;
   writeln('Done scanning.');

   for x:=0 to 255 do chr_srtd[x]:=x;

   for x:=0 to 254 do for y:=x+1 to 255 do
      if chr_fill[chr_srtd[x]]>chr_fill[chr_srtd[y]] then
         begin z:=chr_srtd[x]; chr_srtd[x]:=chr_srtd[y]; chr_srtd[y]:=z end;
   for x:=0 to 255 do begin
      z:=chr_srtd[x];
      y:=z; if y<32 then y:=32;
      writeln(char(y),
            chr_fill[z]:5,
            chr_drct[0,z]:5,
            chr_drct[1,z]:5,
            chr_drct[2,z]:5,
            chr_drct[3,z]:5
            );
{      if x mod 20=19 then readln;
}
   end;
end;

procedure getchar(var c:char;var b:byte;var c0,c1,c2:integer);
var i,j,x,y,z,q:integer;
    sum:array[0..2] of integer;
    suma:integer;
    drct:array[0..3] of integer;
    r1,r2:array[0..4] of single;
    best,rsum:single;
    bc:char;
    q0,q1,q2:integer;
    costs:array[0..255] of single;
    srtd:array[0..255] of integer;

begin
   for q:=0 to 2 do begin
      sum[q]:=0;
      for i:=0 to 3 do for j:=0 to 3 do sum[q]:=sum[q]+matr[q,i,j];
      drct[0]:=0;
      drct[1]:=0;
      drct[2]:=0;
      drct[3]:=0;
      for i:=0 to 2 do for j:=0 to 2 do begin
         y:=abs(matr[q,i,j]-matr[q,i+1,j])+abs(matr[q,i,j+1]-matr[q,i+1,j+1])-
            abs(matr[q,i,j]-matr[q,i,j+1])-abs(matr[q,i+1,j]-matr[q,i+1,j+1]);
         if y>0 then inc(drct[0]);
         if y<0 then inc(drct[2]);
         y:=abs(matr[q,i,j]-matr[q,i+1,j+1])-abs(matr[q,i+1,j]-matr[q,i,j+1]);
         if y>0 then inc(drct[1]);
         if y<0 then inc(drct[3]);
      end;
   end;
   q:=drct[0]+drct[1]+drct[2]+drct[3]+1;
   for x:=0 to 3 do r1[x]:=drct[x]/q;
   sum[0]:=sum[0]+c0;
   sum[1]:=sum[1]+c1;
   sum[2]:=sum[2]+c2;
   suma:=sum[0]+sum[1]+sum[2];
   b:=0;
   q0:=0;
   q1:=0;
   q2:=0;
   if sum[0]>suma/4 then begin b:=b or $04; q0:=1; end;
   if sum[1]>suma/4 then begin b:=b or $02; q1:=1; end;
   if sum[2]>suma/4 then begin b:=b or $01; q2:=1; end;
   if suma>5744+random(500) then begin
      suma:=suma div 3;
      b:=b or $08;
      q0:=q0*3;
      q1:=q1*3;
      q2:=q2*3;
   end;
   r1[4]:=suma/2300;
   best:=100;
   for x:=32 to 127 do begin
      for i:=0 to 3 do r2[i]:=chr_drct[i,x];
      r2[4]:=chr_fill[x]/ 10;
      rsum:=0;
      for i:=0 to 4 do rsum:=rsum+abs(r1[i]-r2[i]);
      costs[x]:=rsum;
   end;
   for x:=32 to 127 do srtd[x-32]:=x;
   for x:=0 to _const3 do for y:=x+1 to 127-32 do
      if costs[srtd[x]]>costs[srtd[y]] then begin
         z:=srtd[x]; srtd[x]:=srtd[y]; srtd[y]:=z;
      end;
{   for x:=0 to 255 do write(costs[srtd[x]]:10:7);}
   bc:=char(srtd[random(_const3+1)]);
   c:=bc;

   c0:=sum[0]-q0*chr_fill[ord(bc)]*_const1;
   c1:=sum[1]-q1*chr_fill[ord(bc)]*_const1;
   c2:=sum[2]-q2*chr_fill[ord(bc)]*_const1;

end;
