unit fliread;

interface

uses dos,crt;
type th1=record
         len:longint;
         sig,chunks:word;
         a:array[0..12] of byte;
         end;
     th2=record
         len:longint;
         typ:word;
         end;
    tscr=array[0..64999] of byte;

const fli_luminozit:single=4;

function newframe:boolean;
procedure fli_open(fliname:string);
procedure fli_getrgb(x,y:word;var r,g,b:byte);

implementation

var scr:^tscr;
    f:file;
    x,y,z,z2,q,w,e:word;
    dat:^tscr;
    nextframe,nextchunk:longint;
    h1:th1;
    h2:th2;
    pall:array[0..255,0..2] of byte;
    rframes:integer;
    p1:pointer;
    nps:word;

procedure fli_getrgb;
var q:byte;
begin
   q:=scr^[x*320+y];
   r:=round(pall[q,0]*fli_luminozit);
   g:=round(pall[q,1]*fli_luminozit);
   b:=round(pall[q,2]*fli_luminozit);
end;

procedure desen(x,y:byte);
var b,b2:byte;
    o,w2:word;
begin
   blockread(f,dat^,h2.len);
   q:=0;
   for w:=x to x+y-1 do begin
      z2:=dat^[q];
      q:=q+1;
      w2:=0;
      for z:=1 to z2 do begin
         w2:=w2+dat^[q];
         b:=dat^[q+1];
         q:=q+2;
         if b>127 then begin
            repeat
            scr^[w*320+w2]:=dat^[q];
            w2:=w2+1;
            b:=b+1;
            until b=0;
            q:=q+1;
            end
                  else for b2:=1 to b do begin
            scr^[w*320+w2]:=dat^[q];
            q:=q+1;
            w2:=w2+1;
                                         end;
                        end;
                    end;
end;

procedure des2;
var b,b2:byte;
    o,w2:word;
begin
   blockread(f,dat^,h2.len);
   q:=0;
   for w:=0 to 199 do begin
      z2:=dat^[q];
      q:=q+1;
      w2:=0;
      for z:=1 to z2 do begin
         b:=dat^[q];
         q:=q+1;
         if b<128 then begin
            repeat
            scr^[w*320+w2]:=dat^[q];
            w2:=w2+1;
            b:=b-1;
            until b=0;
            q:=q+1;
            end
                  else for b2:=1 to 256-b do begin
            scr^[w*320+w2]:=dat^[q];
            q:=q+1;
            w2:=w2+1;
                                             end;
                        end;

                      end;
end;

procedure fli_open;
begin
   assign(f,fliname);
   reset(f,1);
   getmem(p1,65020);
   nps:=seg(p1^);
   scr:=ptr(seg(p1^)+((ofs(p1^)+15) div 16),0);
   seek(f,0);
   blockread(f,dat^,128);
   rframes:=dat^[6]+256*dat^[7];
end;

function newframe;
label l1;
begin
   newframe:=false;
   if rframes=0 then exit;
   newframe:=true;
   rframes:=rframes-1;
   blockread(f,h1,16);
      nextframe:=filepos(f)+h1.len-16;
      for y:=1 to h1.chunks do begin
         blockread(f,h2,6);
         nextchunk:=filepos(f)+h2.len-6;
         case h2.typ of
         11:begin
            blockread(f,dat^,h2.len);
            q:=2;
            w:=0;
            for z:=1 to dat^[0] do begin
               w:=w+dat^[q];
               e:=dat^[q+1];
               q:=q+2;
               if e=0 then e:=256;
               for z2:=1 to e do begin
                  pall[w,0]:=dat^[q];
                  pall[w,1]:=dat^[q+1];
                  pall[w,2]:=dat^[q+2];
                  w:=w+1;
                  q:=q+3;
                                 end;

                                  end;
            end;
         12:begin
            blockread(f,dat^,4);
            h2.len:=h2.len-4;
            desen(dat^[0],dat^[2]);
            end;
         13:for z:=0 to 63999 do scr^[z]:=0;
         15:des2;
         16:blockread(f,scr^,64000);
         end;
         seek(f,nextchunk);
                               end;
      seek(f,nextframe);
     
end;

begin
   new(dat);
end.